package edu.berkeley.cs160.happytoastmobile.BorgTV.DPad;

import edu.berkeley.cs160.happytoastmobile.BorgTV.R;
import android.app.Activity;
import android.os.Bundle;
import android.view.KeyEvent;
import android.widget.Button;
import android.widget.TextView;
import android.widget.Toast;
import android.content.Intent;

public class DPad extends Activity {
    Bundle controls, shortcuts;
    String device;

    /** Called when the activity is first created. */
    public void onCreate(Bundle icicle) {
        super.onCreate(icicle);
        setContentView(R.layout.dpadlayout);
        // Set the BreadCrumbs
        Intent i = getIntent();

        this
                .setTitle(i.getStringExtra("loc") + " > "
                        + i.getStringExtra("room") + " > "
                        + i.getStringExtra("device"));

        controls = i.getBundleExtra("list");
        device = i.getStringExtra("device");

        ShortCuts.makeShortCutMapping();
        if (device.equals("TV") || device.equals("Cable"))
            shortcuts = ShortCuts.TVShortCuts;
        if (device.equals("DVD") || device.equals("DVR"))
            shortcuts = ShortCuts.DVDshortcuts;
        if (device.equals("Stereo"))
            shortcuts = ShortCuts.StearoShortcuts;

        TextView Up, Down, Left, Right, Center;

        Up = (TextView) findViewById(R.id.dpadUp);
        if (shortcuts.getString(controls.getString("Up")) != null)
            Up.setText(controls.getString("Up") + "\n("
                    + shortcuts.getString(controls.getString("Up")) + ")");
        else
            Up.setText(controls.getString("Up"));

        Down = (TextView) findViewById(R.id.dpadDown);

        if (shortcuts.getString(controls.getString("Down")) != null)
            Down.setText(controls.getString("Down") + "\n("
                    + shortcuts.getString(controls.getString("Down")) + ")");
        else
            Down.setText(controls.getString("Down"));

       

        Left = (TextView) findViewById(R.id.dpadLeft);
        if (shortcuts.getString(controls.getString("Left")) != null)
            Left.setText(controls.getString("Left") + "\n("
                + shortcuts.getString(controls.getString("Left")) + ")");
        else 
            Left.setText(controls.getString("Left"));
        
        
        Right = (TextView) findViewById(R.id.dpadRight);
        
        if (shortcuts.getString(controls.getString("Right")) != null)
        Right.setText(controls.getString("Right") + "\n("
                + shortcuts.getString(controls.getString("Right")) + ")");
        else
            Right.setText(controls.getString("Right"));
        
        Center = (TextView) findViewById(R.id.dpadCenter);
        
        if (shortcuts.getString(controls.getString("Center")) != null)
        Center.setText(controls.getString("Center") + "\n("
                + shortcuts.getString(controls.getString("Center")) + ")");
        else
            Center.setText(controls.getString("Center"));
    }

    private void toasty(String signal) {
        Toast temp = Toast.makeText(this, "Signal Sent: " + signal,
                Toast.LENGTH_SHORT);
        temp.show();
    }

    public boolean onKeyDown(int keyCode, KeyEvent event) {
        if (device.equals("TV") || device.equals("Cable"))
            if (ShortCuts.TVShortCuts(keyCode, event, this)
                    || ShortCuts.TVShortCutsChannel(keyCode, event, this))
                return true;

        if (device.equals("DVD") || device.equals("DVR"))
            if (ShortCuts.DVDShortCuts(keyCode, event, this))
                return true;
        if (device.equals("Stereo"))
            if (ShortCuts.stereoShortCuts(keyCode, event, this))
                return true;

        switch (keyCode) {
        case KeyEvent.KEYCODE_DPAD_UP:
            // insert Method here
            toasty(controls.getString("Up"));
            break;
        case KeyEvent.KEYCODE_DPAD_LEFT:
            // insert Method here
            toasty(controls.getString("Left"));

            break;
        case KeyEvent.KEYCODE_DPAD_RIGHT:
            // insert Method here
            toasty(controls.getString("Right"));

            break;
        case KeyEvent.KEYCODE_DPAD_DOWN:
            // insert Method here
            toasty(controls.getString("Down"));

            break;
        case KeyEvent.KEYCODE_DPAD_CENTER:
            // insert Method here
            // IRSubsystem.sendSignal("SonyTV2", "Power");
            toasty(controls.getString("Center"));

            break;
        }

        return super.onKeyDown(keyCode, event);
    }
}