package edu.berkeley.cs160.happytoastmobile.BorgTV.DPad;

import edu.berkeley.cs160.happytoastmobile.BorgTV.R;
import android.app.Activity;
import android.os.Bundle;
import android.view.KeyEvent;
import android.widget.Toast;
import android.content.Intent;

public class NumPad extends Activity {
	Bundle controls;
	String device;
	
    /** Called when the activity is first created. */
    public void onCreate(Bundle icicle) {
        super.onCreate(icicle);
        setContentView(R.layout.numpad);
      //Set the BreadCrumbs
        Intent i = getIntent();
       
        this.setTitle(i.getStringExtra("loc") + " > " +
        		 	  i.getStringExtra("room") + " > " +
           		      i.getStringExtra("device"));
        
        device = i.getStringExtra("device");
    }
    
    
    private void toasty(String signal){
    	Toast temp = Toast.makeText(this, "Signal Sent: " + signal, Toast.LENGTH_SHORT);
    	temp.show();
    }
    
	public boolean onKeyDown(int keyCode, KeyEvent event) {
	    if (device.equals("TV") || device.equals("Cable"))
            if(ShortCuts.TVShortCuts(keyCode, event, this)) return true;
        if (device.equals("DVD") || device.equals("DVR"))
            if(ShortCuts.DVDShortCuts(keyCode, event, this)) return true;
        if (device.equals("Stereo"))
            if(ShortCuts.stereoShortCuts(keyCode,event,this)) return true;
        
        
        switch (keyCode) {
            case KeyEvent.KEYCODE_1:
            case KeyEvent.KEYCODE_W:
                toasty("1");
                break;
            case KeyEvent.KEYCODE_2:
            case KeyEvent.KEYCODE_E:
            	toasty("2");
            	break;
            case KeyEvent.KEYCODE_3:
            case KeyEvent.KEYCODE_R:
            	toasty("3");
            	break;
            case KeyEvent.KEYCODE_4:
            case KeyEvent.KEYCODE_S:
            	toasty("4");
            	break;
            case KeyEvent.KEYCODE_5:
            case KeyEvent.KEYCODE_D:
            	toasty("5");
            	break;
            case KeyEvent.KEYCODE_6:
            case KeyEvent.KEYCODE_F:               
            	toasty("6");
            	break;
            case KeyEvent.KEYCODE_7:
            case KeyEvent.KEYCODE_Z:
            	toasty("7");
            	break;
            case KeyEvent.KEYCODE_8:
            case KeyEvent.KEYCODE_X:
            	toasty("8");
            	break;
            case KeyEvent.KEYCODE_9:
            case KeyEvent.KEYCODE_C:
            	toasty("9");
            	break;
            case KeyEvent.KEYCODE_0:
            case KeyEvent.KEYCODE_AT:
            	toasty("0");
            	break;
            case KeyEvent.KEYCODE_SYM:
            	toasty("100");
            	break;
            case KeyEvent.KEYCODE_SPACE:
            case KeyEvent.KEYCODE_TAB:
            	toasty("ENTER");
            	break;
            }
        return super.onKeyDown(keyCode, event);
    }
}