package edu.berkeley.cs160.happytoastmobile.BorgTV.DPad;

import android.content.Context;
import android.os.Bundle;
import android.view.KeyEvent;
import android.widget.Toast;

public class ShortCuts {
    static public Bundle TVShortCuts = new Bundle();
    static public Bundle TVshortcutsChannel = new Bundle();
    static public Bundle DVDshortcuts = new Bundle();
    static public Bundle StearoShortcuts = new Bundle();


	/** The shortcuts for a TV
	 * 
	 * P : Power
	 * Vol +/- : Volume +/-
	 * T/G : CH Up/Down
	 * M : Mute
	 */
	static public boolean TVShortCuts (int keyCode, KeyEvent event, Context context) {
		
	    switch (keyCode) {
		case KeyEvent.KEYCODE_P:
			toasty("POWER", context);
			return true;
		case KeyEvent.KEYCODE_VOLUME_UP:
			toasty("VOL +", context);
			return true;
		case KeyEvent.KEYCODE_VOLUME_DOWN:
			toasty("VOL -", context);
			return true;
		case KeyEvent.KEYCODE_T:
            toasty("CH UP", context);
            return true;
        case KeyEvent.KEYCODE_G:
            toasty("CH DOWN", context);
            return true;
        case KeyEvent.KEYCODE_M:
            toasty("MUTE", context);
            return true;
        case KeyEvent.KEYCODE_NEWLINE:
            toasty("MENU", context);
            return true;
        case KeyEvent.KEYCODE_I:
            toasty("INPUT", context);
            return true;
		default:
			return false;
		}
	}
	
	static public boolean TVShortCutsChannel (int keyCode, KeyEvent event, Context context) {	

	    switch (keyCode) {
        case KeyEvent.KEYCODE_1:
        case KeyEvent.KEYCODE_W:
            toasty("1", context);
            return true;
        case KeyEvent.KEYCODE_2:
        case KeyEvent.KEYCODE_E:
            toasty("2", context);
            return true;
        case KeyEvent.KEYCODE_3:
        case KeyEvent.KEYCODE_R:
            toasty("3", context);
            return true;
        case KeyEvent.KEYCODE_4:
        case KeyEvent.KEYCODE_S:
            toasty("4", context);
            return true;
        case KeyEvent.KEYCODE_5:
        case KeyEvent.KEYCODE_D:
            toasty("5", context);
            return true;
        case KeyEvent.KEYCODE_6:
        case KeyEvent.KEYCODE_F:               
            toasty("6", context);
            return true;
        case KeyEvent.KEYCODE_7:
        case KeyEvent.KEYCODE_Z:
            toasty("7", context);
            return true;
        case KeyEvent.KEYCODE_8:
        case KeyEvent.KEYCODE_X:
            toasty("8", context);
            return true;
        case KeyEvent.KEYCODE_9:
        case KeyEvent.KEYCODE_C:
            toasty("9", context);
            return true;
        case KeyEvent.KEYCODE_0:
        case KeyEvent.KEYCODE_AT:
            toasty("0", context);
            return true;
        case KeyEvent.KEYCODE_SYM:
            toasty("100", context);
            return true;
        case KeyEvent.KEYCODE_SPACE:
        case KeyEvent.KEYCODE_TAB:
            toasty("ENTER", context);
            return true;
        default: 
            return false;
        } 
	}
	/** 
	 * DVD Shortcuts:
	 * P : Power
	 * Space : Play
	 * / : Pause
	 * B/N : Rewind/Forward
	 * M : Chapter Menu
	 * */
	static public boolean DVDShortCuts(int keyCode, KeyEvent event, Context context) {
        	   
	    switch (keyCode) { 
	    case KeyEvent.KEYCODE_P:
	        toasty("POWER", context);
	        return true;
	    case KeyEvent.KEYCODE_SPACE:
	        toasty("PLAY", context);
	        return true;
	    case KeyEvent.KEYCODE_SLASH:
	        toasty("PAUSE", context);
	        return true;
	    case KeyEvent.KEYCODE_B:
	        toasty("REWIND", context);
	        return true;
	    case KeyEvent.KEYCODE_N:
	        toasty("FORWARD", context);
	        return true;
	    case KeyEvent.KEYCODE_M:
	        toasty("CHAPTER MENU", context);
	        return true;
	    default:
	        return false;
	    }
	}
	/**
	 * Stereo Shortcuts:
	 * P : Power
	 * Vol +/-: Vol +/-
	 * T/G : Front +/-
	 * B/N : Left/Right +
	 * Y/H : Bass +/-
	 * U/J : Treble +/-
	 * I/K : Next/Prev input
	 */
	static public boolean stereoShortCuts(int keyCode, KeyEvent event, Context context) {

	    switch (keyCode) {
        case KeyEvent.KEYCODE_P:
            toasty("POWER", context);
            return true;
        case KeyEvent.KEYCODE_VOLUME_UP:
            toasty("VOL +", context);
            return true;
        case KeyEvent.KEYCODE_VOLUME_DOWN:
            toasty("VOL -", context);
            return true;
        case KeyEvent.KEYCODE_T:
            toasty("FRONT +", context);
            return true;
        case KeyEvent.KEYCODE_G:
            toasty("BACK -", context);
            return true;
        case KeyEvent.KEYCODE_B:
            toasty("LEFT +", context);
            return true;
        case KeyEvent.KEYCODE_N:
            toasty("RIGHT +", context);
            return true;
        case KeyEvent.KEYCODE_Y:
            toasty("BASS +", context);
            return true;
        case KeyEvent.KEYCODE_H:
            toasty("BASS -", context);
            return true;
        case KeyEvent.KEYCODE_U:
            toasty("TREBLE +", context);
            return true;
        case KeyEvent.KEYCODE_J:
            toasty("TREBLE -", context);
            return true;
        case KeyEvent.KEYCODE_I:
            toasty("NEXT INPUT", context);
            return true;
        case KeyEvent.KEYCODE_K:
            toasty("PREV INPUT", context);
            return true;
        default:
            return false;
        }
    }
	
    static private void toasty(String signal, Context context){
    	Toast temp = Toast.makeText(context, "Signal Sent: " + signal, Toast.LENGTH_SHORT);
    	temp.show();
    }
    
    static public void makeShortCutMapping() {
        TVShortCuts.putString("POWER", "P");
        TVShortCuts.putString("VOL +", "VOL +");
        TVShortCuts.putString("VOL -", "VOL -");
        TVShortCuts.putString("CH UP", "T");
        TVShortCuts.putString("CH DOWN", "G");
        TVShortCuts.putString("MUTE", "M");
        TVShortCuts.putString("MENU", "RETURN");
        TVShortCuts.putString("INPUT", "I");

        
        TVshortcutsChannel.putString("1", "1");
        TVshortcutsChannel.putString("2", "2");
        TVshortcutsChannel.putString("3", "3");
        TVshortcutsChannel.putString("4", "4");
        TVshortcutsChannel.putString("5", "5");
        TVshortcutsChannel.putString("6", "6");
        TVshortcutsChannel.putString("7", "7");
        TVshortcutsChannel.putString("8", "8");
        TVshortcutsChannel.putString("9", "9");
        TVshortcutsChannel.putString("0", "0");
        TVshortcutsChannel.putString("100", "SYM");
        TVshortcutsChannel.putString("ENTER", "SPACE");
        
        DVDshortcuts.putString("POWER", "P");
        DVDshortcuts.putString("PLAY", "SPACE");
        DVDshortcuts.putString("PAUSE", "SLASH");
        DVDshortcuts.putString("REWIND", "B");
        DVDshortcuts.putString("FORWARD", "N");
        DVDshortcuts.putString("CHAPTER MENU", "M");
        
        StearoShortcuts.putString("POWER","P");
        StearoShortcuts.putString("VOL +","VOL +");
        StearoShortcuts.putString("VOL -","VOL -");
        StearoShortcuts.putString("FRONT +","T");
        StearoShortcuts.putString("BACK -","G");
        StearoShortcuts.putString("LEFT +","B");
        StearoShortcuts.putString("RIGHT +","N");
        StearoShortcuts.putString("BASS +","Y");
        StearoShortcuts.putString("BASS -","H");
        StearoShortcuts.putString("TREBLE +","U");
        StearoShortcuts.putString("TREBLE +","J");
        StearoShortcuts.putString("NEXT INPUT","I");
        StearoShortcuts.putString("PREV INPUT","K");
        
    }
}
