package edu.berkeley.cs160.happytoastmobile.BorgTV;

import android.net.Uri;
import android.provider.BaseColumns;

public final class DataDefs {
	public static final class Fields implements BaseColumns {
        /**
         * The content:// style URL for this table
         */
        public static final Uri CONTENT_URI
                = Uri.parse("content://edu.berkeley.cs160.happytoastmobile.BorgTV.DataDefs/locations");

        public static final String DEFAULT_SORT_ORDER = "location DESC";
        public static final String LOCATION = "location";
        public static final String ROOM = "room";
        public static final String DEVICE = "device";

        /** Creates the Uri for querying all locations*/
        public static Uri mkQueryUri(){
            return Uri.parse("content://edu.berkeley.cs160.happytoastmobile.BorgTV.DataDefs/locations");
        }
        /** Creates the Uri for querying all rooms at a given location. There can't be NO ROOMS! If
         * this is the case then when querying for devices, pass the EMPTY string "" to the device
         * list query
         */
        public static Uri mkQueryUri(String loc){
            return Uri.parse("content://edu.berkeley.cs160.happytoastmobile.BorgTV.DataDefs/locations/"+loc+"/rooms");
        }
        /** Creates the Uri for querying all devices at a given Location & Room pair. Room can be EMPTY.
         * Because of implementation details, the return value of this query may have null devices in it.
         * You will have to weed them out yourself. */
        public static Uri mkQueryUri(String loc, String room){
            return Uri.parse("content://edu.berkeley.cs160.happytoastmobile.BorgTV.DataDefs/locations/"+loc+"/rooms/"+room+"/devices");
        }
        /** Creates the Uri for inserting a location*/
        public static Uri mkInsertUri(String loc, int locPlacement){
            return Uri.parse("content://edu.berkeley.cs160.happytoastmobile.BorgTV.DataDefs/locations/"+loc+"/"+locPlacement);
        }
        /** Creates the Uri for inserting a room at a given location*/
        public static Uri mkInsertUri(String loc, String room, int roomPlacement){
            return Uri.parse("content://edu.berkeley.cs160.happytoastmobile.BorgTV.DataDefs/locations/"+loc+"/rooms/"+room+"/"+roomPlacement);
        }
        /** Creates the Uri for inserting a device at a given location & room pair. Room can be EMPTY*/
        public static Uri mkInsertUri(String loc, String room, String device, int devicePlacement){
            return Uri.parse("content://edu.berkeley.cs160.happytoastmobile.BorgTV.DataDefs/locations/"+loc+"/rooms/"+room+"/devices/"+device+"/"+devicePlacement);
        }
    }
}
