package edu.berkeley.cs160.happytoastmobile.BorgTV.NineButton;

import edu.berkeley.cs160.happytoastmobile.BorgTV.R;
import edu.berkeley.cs160.happytoastmobile.BorgTV.Setup.Setup;
import edu.berkeley.cs160.happytoastmobile.BorgTV.DataDefs;

import android.app.Activity;
import android.net.Uri;
import android.os.Bundle;
import android.view.KeyEvent;
import android.view.View;
import android.widget.Button;
import android.content.Intent;
import android.database.Cursor;

public class Menu extends Activity {
	Cursor data;
	private int currSetupPlacement;
	private SetNineButtons basicButtons;
	private String loc, room, device;
	
    public static final String LOC_ACTION = "loc_action";
    public static final String ROOM_ACTION = "room_action";
    public static final String DEVICE_ACTION = "dev_action";
	
	String action;
	Intent whoCalled;
	
	//All the locations for more menu
	private Bundle moreList;

	public void onCreate(Bundle icicle) {
		super.onCreate(icicle);
		setContentView(R.layout.ninebuttonlayout);
		whoCalled = getIntent();
		action = whoCalled.getAction();
		moreList = new Bundle();
		
		setTitle();
		
		basicButtons = new SetNineButtons(this);
		basicButtons.back.requestFocus();
		
		basicButtons.help.setOnClickListener(new Button.OnClickListener() {
			public void onClick(View v) {
				help();
			}
		});

		basicButtons.more.setOnClickListener(new Button.OnClickListener() {
			public void onClick(View v) {
				more();
			}
		});

		Uri uri = DataDefs.Fields.mkQueryUri();
		data = this.managedQuery(uri, null, null, null);
		
		setNewButtons();
		propagate();
		setButtons();
		if (data.count() == 1 && data.first()) {
			goIntoNextLevel(data.getString(0));
		}
	}

	void setTitle() {
		if (action == null) 
			this.setTitle("BorgTV2");
		else if (action.equals(LOC_ACTION)) {
			loc = whoCalled.getStringExtra("loc");
			this.setTitle(loc);
		} else if (action.equals(ROOM_ACTION)) 
			loc = whoCalled.getStringExtra("loc");
			room = whoCalled.getStringExtra("room");
			this.setTitle(loc + " > " 
						 + room);
	}
	
	void setNewButtons() {
		for (int i = SetNineButtons.CENTER; i < 5; i++) {
			if (action == null) 
				basicButtons.getButton(i).setText("New Location");
			else if (action.equals(LOC_ACTION)) 
				basicButtons.getButton(i).setText("New Room");
			else if (action.equals(ROOM_ACTION)) 
				basicButtons.getButton(i).setText("New Device");
		}
	}
	
	void setButtons() {
		if(basicButtons.center.getText().equals("New Location") ||
		   basicButtons.center.getText().equals("New Room") ||
		   basicButtons.center.getText().equals("New Device"))
		   basicButtons.center.setOnClickListener(new Button.OnClickListener() {
				public void onClick(View v) {
					setup(SetNineButtons.CENTER);
				}
			});
		else 
			basicButtons.center.setOnClickListener(new Button.OnClickListener() {
				public void onClick(View v) {
					goIntoNextLevel (basicButtons.center.getText());
				}
			});

		if( basicButtons.up.getText().equals("New Location") ||
		    basicButtons.up.getText().equals("New Room") ||
		    basicButtons.up.getText().equals("New Device"))
			
		    basicButtons.up.setOnClickListener(new Button.OnClickListener() {
				public void onClick(View v) {
					setup(SetNineButtons.UP);
				}
			});
		else 
			basicButtons.up.setOnClickListener(new Button.OnClickListener() {
				public void onClick(View v) {
					goIntoNextLevel (basicButtons.up.getText());
				}
			});


		if( basicButtons.down.getText().equals("New Location") ||
		    basicButtons.down.getText().equals("New Room") ||
		    basicButtons.down.getText().equals("New Device"))
			
			basicButtons.down.setOnClickListener(new Button.OnClickListener() {
				public void onClick(View v) {
					setup(SetNineButtons.DOWN);
				}
			});
		else 
			basicButtons.down.setOnClickListener(new Button.OnClickListener() {
				public void onClick(View v) {
					goIntoNextLevel (basicButtons.down.getText());
				}
			});


		if(	basicButtons.left.getText().equals("New Location") ||
			basicButtons.left.getText().equals("New Room") ||
		    basicButtons.left.getText().equals("New Device"))
			
			basicButtons.left.setOnClickListener(new Button.OnClickListener() {
				public void onClick(View v) {
					setup(SetNineButtons.LEFT);
				}
			});
		else 
			basicButtons.left.setOnClickListener(new Button.OnClickListener() {
				public void onClick(View v) {
					goIntoNextLevel (basicButtons.left.getText());
				}
			});


		if( basicButtons.right.getText().equals("New Location") ||
		    basicButtons.right.getText().equals("New Room") ||
		    basicButtons.right.getText().equals("New Device"))
			
			basicButtons.right.setOnClickListener(new Button.OnClickListener() {
				public void onClick(View v) {
					setup(SetNineButtons.RIGHT);
				}
			});
		else 
			basicButtons.right.setOnClickListener(new Button.OnClickListener() {
				public void onClick(View v) {
					goIntoNextLevel (basicButtons.right.getText());
				}
			});
	}
	
	void propagate() {
		if(data.first())
			for(int i = 0; i < data.count(); i++) {
				String nameRoom = data.getString(0);
				int placement = data.getInt(1);
				
				if (!nameRoom.equals("New Location"))
					moreList.putString(Integer.toString(placement), nameRoom);
				
				basicButtons.getButton(placement).setText(nameRoom);
				
				if (!data.next())
					break;
			}
	}

	void setup (int placement) {
		if (action == null) {
			Intent i = new Intent(this, Setup.class);
			i.putExtra("placement", placement);
			i.setAction(Setup.ADD_LOC_ACTION);
			startSubActivity(i, 0);	
			currSetupPlacement = placement;
		} else if (action.equals(LOC_ACTION)) {
			Intent i = new Intent(this, Setup.class);
			i.putExtra("placement", placement);
			i.setAction(Setup.ADD_ROOM_ACTION);
			startSubActivity(i, 0);
		} else if (action.equals(ROOM_ACTION)) {
			Intent i = new Intent(this, Setup.class);
			i.putExtra("placement", placement);
			i.setAction(Setup.ADD_DEVICE_ACTION);
			startSubActivity(i, 0);
		}	
	}

	void help () {
		Intent help = new Intent(this, Help.class);
		help.putExtra("caller", "BorgTV");
		help.putExtra("message", "put some stuff here");
		startSubActivity(help, 0);
	}

	void more() {
		Intent i = new Intent(this, More.class);
		i.putExtra("caller", "BorgTV");
		i.putExtra("message", "put some stuff here");
		i.putExtra("list", moreList);
		startSubActivity(i, 0);
		
	}
 

	void goIntoNextLevel (CharSequence data) {
		Intent nextLevel = new Intent(this, Menu.class);
		if (action == null) {
			nextLevel.putExtra("loc", data);
			nextLevel.setAction(LOC_ACTION);
			startSubActivity(nextLevel, 0);
		} else if (action.equals(LOC_ACTION)) {
			nextLevel.putExtra("loc", this.loc);
			nextLevel.putExtra("room", data);
			nextLevel.setAction(ROOM_ACTION);
		} else if (action.equals(ROOM_ACTION)) {
			nextLevel = new Intent(this, MenuDevices.class);
			nextLevel.putExtra("loc", this.loc);
			nextLevel.putExtra("room", this.room);
			nextLevel.putExtra("device", data);
		}	
	}

	protected void onActivityResult(int requestCode, int resultCode,
			String data, Bundle extras) {
		if(resultCode == RESULT_OK) {
			basicButtons.getButton(currSetupPlacement).setText(data);
			goIntoNextLevel(data);
			setButtons();
		} else if (resultCode == Codes.SELECT) {
			goIntoNextLevel(data);
		} else if (resultCode == Codes.RENAME) {
			//TODO: IMPLIMENT THIS
		} else if (resultCode == Codes.DELETE) {
			getContentResolver().delete(DataDefs.Fields.mkInsertUri(data, 0), null, null);
		}
	}
	
	public boolean onKeyUp(int keyCode, KeyEvent event) {
        switch (keyCode) {
            case KeyEvent.KEYCODE_1:
            case KeyEvent.KEYCODE_W:
                basicButtons.guide();
                break;
            case KeyEvent.KEYCODE_2:
            case KeyEvent.KEYCODE_E:
        		if(basicButtons.up.getText().equals("New Location") ||
       			   basicButtons.up.getText().equals("New Room") ||
  				   basicButtons.up.getText().equals("New Device"))
                    setup(SetNineButtons.UP);
                else
                    goIntoNextLevel(basicButtons.up.getText());
                break;
            case KeyEvent.KEYCODE_3:
            case KeyEvent.KEYCODE_R:
                help();
                break;
            case KeyEvent.KEYCODE_4:
            case KeyEvent.KEYCODE_S:
        		if(basicButtons.left.getText().equals("New Location") ||
        		   basicButtons.left.getText().equals("New Room") ||
        	       basicButtons.left.getText().equals("New Device"))
            	
                    setup(SetNineButtons.LEFT);
                else
                    goIntoNextLevel(basicButtons.left.getText());
                break;
            case KeyEvent.KEYCODE_5:
            case KeyEvent.KEYCODE_D:
            	if(basicButtons.center.getText().equals("New Location") ||
                   basicButtons.center.getText().equals("New Room") ||
                   basicButtons.center.getText().equals("New Device"))                    setup(SetNineButtons.CENTER);
                else
                    goIntoNextLevel(basicButtons.center.getText());
                break;
                
            case KeyEvent.KEYCODE_6:
            case KeyEvent.KEYCODE_F:               
        		if(basicButtons.right.getText().equals("New Location") ||
        		   basicButtons.right.getText().equals("New Room") ||
        		   basicButtons.right.getText().equals("New Device"))
                    setup(SetNineButtons.RIGHT);
                else
                    goIntoNextLevel(basicButtons.right.getText());
                break;
                
            case KeyEvent.KEYCODE_7:
            case KeyEvent.KEYCODE_Z:
                this.finish();
                break;
                
            case KeyEvent.KEYCODE_8:
            case KeyEvent.KEYCODE_X:
        		if(basicButtons.down.getText().equals("New Location") ||
        		   basicButtons.down.getText().equals("New Room") ||
       			   basicButtons.down.getText().equals("New Device"))
                    setup(SetNineButtons.DOWN);
                else
                    goIntoNextLevel(basicButtons.down.getText());
                break;              
                
            case KeyEvent.KEYCODE_9:
            case KeyEvent.KEYCODE_C:
                more();
                break;
            }
        return super.onKeyUp(keyCode, event);
    }
}
