package edu.berkeley.cs160.happytoastmobile.BorgTV.NineButton;

import edu.berkeley.cs160.happytoastmobile.BorgTV.DataDefs;
import edu.berkeley.cs160.happytoastmobile.BorgTV.R;
import edu.berkeley.cs160.happytoastmobile.BorgTV.Setup.Setup;
import edu.berkeley.cs160.happytoastmobile.BorgTV.DPad.*;

import android.app.Activity;
import android.content.Intent;
import android.database.Cursor;
import android.graphics.Color;
import android.net.Uri;
import android.os.Bundle;
import android.util.Log;
import android.view.KeyEvent;
import android.view.Menu;
import android.view.View;
import android.widget.Button;

public class MenuDevices extends Activity {

    public class Set {
        static final int CHVOL = 1000;
        static final int POWER = 1001;
        static final int DVDBASIC = 1002;
        static final int NUMPAD = 1003;
        static final int MENU_NAV = 1004;
        static final int CHAPTER_FXN = 1005;
        static final int CABLE_GUIDE = 1006;
        static final int EQUALIZER = 1007;
        static final int VOL_INPUTS = 1008;
        static final int BALANCE = 1009;
    }

    Cursor data;
    private int currSetupPlacement;
    private SetNineButtons basicButtons;
    private Bundle moreCtrl = new Bundle();
    private Bundle moreCtrlCodes = new Bundle();
    private Bundle moreShortCuts = new Bundle();

    String loc, room, device;

    public void onCreate(Bundle icicle) {
        super.onCreate(icicle);
        setContentView(R.layout.ninebuttonlayout);
        this.findViewById(R.id.backgroundLayout).setBackground(R.drawable.purplebackground);
        
        ShortCuts.makeShortCutMapping();

        basicButtons = new SetNineButtons(this);

        basicButtons.help.setOnClickListener(new Button.OnClickListener() {
            public void onClick(View v) {
                help();
            }
        });

        basicButtons.more.setOnClickListener(new Button.OnClickListener() {
            public void onClick(View v) {
                more();
            }
        });

        // User cannot create a new Operations. Making all Buttons blank.
        basicButtons.center.setText("");
        basicButtons.up.setText("");
        basicButtons.down.setText("");
        basicButtons.left.setText("");
        basicButtons.right.setText("");

        basicButtons.back.requestFocus();

        Intent i = getIntent();
        loc = i.getStringExtra("loc");
        room = i.getStringExtra("room");
        device = i.getStringExtra("device");

        checkTitle();

        if (device.equals("TV") || device.equals("Cable"))
            TV();
        if (device.equals("DVD") || device.equals("DVR"))
            DVD();
        if (device.equals("Stereo"))
            Stereo();
    }

    void checkTitle() {
        Intent i = getIntent();
        if (i.getBooleanExtra("oneRoom", false)) {
            this.setTitle("BorgTV > " + loc + " > " + device);
        } else {
            this.setTitle("BorgTV > " + loc + " > " + room + " > " + device);
        }
    }

    void Stereo() {
        basicButtons.left.setText("Equalizer");
        moreCtrlCodes.putInt("Equalizer", Set.EQUALIZER);
        basicButtons.left.setOnClickListener(new Button.OnClickListener() {
            public void onClick(View v) {
                goIntoNextLevel(Set.EQUALIZER);
            }
        });
        basicButtons.center.setText("Vol/Inputs");
        moreCtrlCodes.putInt("Vol/Inputs", Set.VOL_INPUTS);
        basicButtons.center.setOnClickListener(new Button.OnClickListener() {
            public void onClick(View v) {
                goIntoNextLevel(Set.VOL_INPUTS);
            }
        });
        basicButtons.right.setText("Balance");
        moreCtrlCodes.putInt("Balance", Set.BALANCE);
        basicButtons.right.setOnClickListener(new Button.OnClickListener() {
            public void onClick(View v) {
                goIntoNextLevel(Set.BALANCE);
            }
        });
    }

    void TV() {
        basicButtons.center.setText("Ch/Vol");
        basicButtons.left.setText("Power");
        basicButtons.right.setText("Number Pad");
        basicButtons.down.setText("Menu Navigation");
        basicButtons.up.setFocusable(false);
        moreCtrl.putString("Ch/Vol", "Ch/Vol");
        moreCtrlCodes.putInt("Ch/Vol", Set.CHVOL);
        moreCtrl.putString("Power", "Power");
        moreCtrlCodes.putInt("Power", Set.POWER);
        moreCtrl.putString("Number Pad", "Number Pad");
        moreCtrlCodes.putInt("Number Pad", Set.NUMPAD);

        basicButtons.center.setOnClickListener(new Button.OnClickListener() {
            public void onClick(View v) {
                goIntoNextLevel(Set.CHVOL);
            }
        });

        basicButtons.left.setOnClickListener(new Button.OnClickListener() {
            public void onClick(View v) {
                goIntoNextLevel(Set.POWER);
            }
        });

        basicButtons.right.setOnClickListener(new Button.OnClickListener() {
            public void onClick(View v) {
                goIntoNextLevel(Set.NUMPAD);
            }
        });
        basicButtons.down.setOnClickListener(new Button.OnClickListener() {
            public void onClick(View v) {
                goIntoNextLevel(Set.MENU_NAV);
            }
        });
    }

    void DVD() {
        basicButtons.left.setText("Basic Funtions");
        basicButtons.center.setText("Menu Navigation");
        basicButtons.right.setText("Chapter Navigation");
        basicButtons.down.setFocusable(false);
        basicButtons.up.setFocusable(false);
        moreCtrl.putString("Basic Functions", "Basic Functions");
        moreCtrlCodes.putInt("Basic Functions", Set.DVDBASIC);
        moreCtrl.putString("Menu Navigation", "Menu Navigation");
        moreCtrlCodes.putInt("Menu Navigation", Set.MENU_NAV);
        moreCtrlCodes.putInt("Chapter Navigation", Set.CHAPTER_FXN);

        basicButtons.left.setOnClickListener(new Button.OnClickListener() {
            public void onClick(View v) {
                goIntoNextLevel(Set.DVDBASIC);
            }
        });
        basicButtons.center.setOnClickListener(new Button.OnClickListener() {
            public void onClick(View v) {
                goIntoNextLevel(Set.MENU_NAV);
            }
        });
        basicButtons.right.setOnClickListener(new Button.OnClickListener() {
            public void onClick(View v) {
                goIntoNextLevel(Set.CHAPTER_FXN);
            }
        });
    }

    Bundle getSetBundle(int code) {
        Bundle TVControls = new Bundle();
        switch (code) {
        case Set.CHVOL:
            TVControls.putString("Up", "CH UP");
            TVControls.putString("Down", "CH DOWN");
            TVControls.putString("Right", "VOL +");
            TVControls.putString("Left", "VOL -");
            TVControls.putString("Center", "MENU");
            break;
        case Set.POWER:
            TVControls.putString("Up", "MENU");
            TVControls.putString("Down", "INPUT");
            TVControls.putString("Right", "SLEEP");
            TVControls.putString("Left", "MUTE");
            TVControls.putString("Center", "POWER");
            break;
        case Set.DVDBASIC:
            TVControls.putString("Up", "PLAY");
            TVControls.putString("Down", "PAUSE");
            TVControls.putString("Right", "FORWARD");
            TVControls.putString("Left", "REWIND");
            TVControls.putString("Center", "STOP");
            break;
        case Set.MENU_NAV:
            TVControls.putString("Up", "UP");
            TVControls.putString("Down", "DOWN");
            TVControls.putString("Right", "RIGHT");
            TVControls.putString("Left", "LEFT");
            TVControls.putString("Center", "ENTER");
            break;
        case Set.CHAPTER_FXN:
            TVControls.putString("Up", "LAST CHAPTER");
            TVControls.putString("Down", "FIRST CHAPTER");
            TVControls.putString("Right", "SKIP BACKWARD");
            TVControls.putString("Left", "SKIP FORWARD");
            TVControls.putString("Center", "CHAPTER MENU");
            break;
        case Set.BALANCE:
            TVControls.putString("Up", "FRONT +");
            TVControls.putString("Down", "BACK +");
            TVControls.putString("Right", "RIGHT +");
            TVControls.putString("Left", "LEFT +");
            TVControls.putString("Center", "RESET");
            break;
        case Set.VOL_INPUTS:
            TVControls.putString("Up", "VOL +");
            TVControls.putString("Down", "VOL -");
            TVControls.putString("Right", "NEXT INPUT");
            TVControls.putString("Left", "PREV INPUT");
            TVControls.putString("Center", "MUTE");
            break;
        case Set.EQUALIZER:
            TVControls.putString("Up", "BASS +");
            TVControls.putString("Down", "BASS -");
            TVControls.putString("Right", "TREBLE +");
            TVControls.putString("Left", "TREBLE -");
            TVControls.putString("Center", "RESET");
            break;
        /*
         * case Set.: TVControls.putString("Up", "");
         * TVControls.putString("Down", ""); TVControls.putString("Right", "");
         * TVControls.putString("Left", ""); TVControls.putString("Center", "");
         * break;
         */
        default:
            return null;
        }

        return TVControls;
    }

    void help() {
        Intent help = new Intent(this, Help.class);
        help.putExtra("caller", "Devices");
        help.putExtra("message", "TV operations");
        startSubActivity(help, 0);
    }

    void more() {
        Intent i = new Intent(this, More.class);
        i.putExtra("caller", "device");
        i.putExtra("type", device);
        i.putExtra("message", "put some stuff here");
        i.putExtra("list", moreCtrl);
        i.putExtra("codes", moreCtrlCodes);
        i.putExtra("resultList", createActivityPendingResult(Codes.LOCATION, true));
        startSubActivity(i, 0);
    }

    void goIntoNextLevel(int code) {
        Intent i = new Intent();
        i.putExtra("loc", loc);
        i.putExtra("room", room);
        i.putExtra("device", device);

        if (code == Set.NUMPAD) {
            i.setClass(this, NumPad.class);
            startSubActivity(i, 0);
        } else {
            i.putExtra("list", getSetBundle(code));
            i.setClass(this, DPad.class);
            startSubActivity(i, 0);
        }
    }

    void goIntoNextLevel(CharSequence str) {
        goIntoNextLevel(moreCtrlCodes.getInt(str.toString()));
    }

    protected void onActivityResult(int requestCode, int resultCode,
            String data, Bundle extras) {
        if (resultCode == Codes.SELECT) {
            goIntoNextLevel(data);
        }

        if (resultCode == Setup.DEVICE_COLLISION) {
            setResult(Setup.DEVICE_COLLISION, data);
            finish();
        }
    }

    public boolean onKeyDown(int keyCode, KeyEvent event) {
        if (device.equals("TV") || device.equals("Cable"))
            if (ShortCuts.TVShortCuts(keyCode, event, this))
                return true;
        if (device.equals("DVD") || device.equals("DVR"))
            if (ShortCuts.DVDShortCuts(keyCode, event, this))
                return true;
        if (device.equals("Stereo"))
            if (ShortCuts.stereoShortCuts(keyCode, event, this))
                return true;

        switch (keyCode) {
        case KeyEvent.KEYCODE_1:
        case KeyEvent.KEYCODE_W:
            basicButtons.guide();
            break;
        case KeyEvent.KEYCODE_2:
        case KeyEvent.KEYCODE_E:
            if (!basicButtons.up.getText().equals(""))
                goIntoNextLevel(basicButtons.up.getText());
            break;
        case KeyEvent.KEYCODE_3:
        case KeyEvent.KEYCODE_R:
            help();
            break;
        case KeyEvent.KEYCODE_4:
        case KeyEvent.KEYCODE_S:
            if (!basicButtons.center.getText().equals(""))
                goIntoNextLevel(basicButtons.left.getText());
            break;
        case KeyEvent.KEYCODE_5:
        case KeyEvent.KEYCODE_D:
            if (!basicButtons.center.getText().equals(""))
                goIntoNextLevel(basicButtons.center.getText());
            break;

        case KeyEvent.KEYCODE_6:
        case KeyEvent.KEYCODE_F:
            if (!basicButtons.right.getText().equals(""))
                goIntoNextLevel(basicButtons.right.getText());
            break;

        case KeyEvent.KEYCODE_7:
        case KeyEvent.KEYCODE_Z:
            this.finish();
            break;

        case KeyEvent.KEYCODE_8:
        case KeyEvent.KEYCODE_X:
            if (!basicButtons.down.getText().equals(""))
                goIntoNextLevel(basicButtons.down.getText());
            break;

        case KeyEvent.KEYCODE_9:
        case KeyEvent.KEYCODE_C:
            more();
            break;
        }
        return super.onKeyDown(keyCode, event);
    }


    public boolean onOptionsItemSelected(Menu.Item item) {
        Intent i = new Intent(this, Edit.class);
        switch (item.getId()) {
        case 0:
            i.setAction(Edit.RENAME);
            startSubActivity(i, 0);
            return true;
        case 1:
            i.setAction(Edit.RENAME);
            startSubActivity(i, 0);
            return true;
        }

        return false;
    }

}