package edu.berkeley.cs160.happytoastmobile.BorgTV.NineButton;

import java.util.Iterator;
import java.util.Set;

import edu.berkeley.cs160.happytoastmobile.BorgTV.DataDefs;
import edu.berkeley.cs160.happytoastmobile.BorgTV.R;
import edu.berkeley.cs160.happytoastmobile.BorgTV.Setup.Setup;
import edu.berkeley.cs160.happytoastmobile.BorgTV.DPad.*;


import android.os.Bundle;
import android.view.KeyEvent;
import android.view.Menu;
import android.view.View;
import android.view.ViewGroup;
import android.widget.AdapterView;
import android.widget.BaseAdapter;
import android.widget.ListView;
import android.widget.Spinner;
import android.widget.TextView;
import android.widget.Button;
import android.widget.Toast;
import android.app.ActivityPendingResult;
import android.app.ListActivity;
import android.content.Context;
import android.content.Intent;

public class More extends ListActivity {
    // Used for getting extras passed from who called me
    Intent i;
    Bundle list, codes;
    ActivityPendingResult resultList;
    MoreListAdapter viewList;

    public void onCreate(Bundle icicle) {
        i = getIntent();
        super.onCreate(icicle);

        if (i.getStringExtra("caller").equals("device")) {
            this.setTitle("More: " + i.getStringExtra("type"));
            createDeviceList(i.getStringExtra("type"));
            viewList = new MoreListAdapter(this, mStrings);
            setListAdapter(viewList);
        } else {
            this.setTitle("More: " + i.getStringExtra("caller"));
            resultList = (ActivityPendingResult) i
                    .getParcelableExtra("resultList");

            createList();
            viewList = new MoreListAdapter(this, mStrings);
            setListAdapter(viewList);
        }
    }

    

    protected void onListItemClick(ListView l, View v, int position, long id) {
        Intent i = getIntent();
        if (mStrings[position].equals("Help")) {
            Intent help = new Intent(this, Help.class);
            help.putExtra("caller", i.getStringExtra("caller"));
            help.putExtra("message", i.getStringExtra("message"));
            startSubActivity(help, 0);
        } else if (mStrings[position].equals("Back")) {
            finish();
        } else if (mStrings[position].equals("New Location")
                || mStrings[position].equals("New Room")
                || mStrings[position].equals("New Device")) {
            setResult(Codes.NEW, mStrings[position]);
            finish();
        } else if (i.getStringExtra("caller").equals("device") && position > list.size()) {
            toasty (mStrings[position]);
        } else {
            setResult(Codes.SELECT, mStrings[position]);
            finish();
        }

    }
    
    private void toasty(String signal){
        Toast temp = Toast.makeText(this, "Signal Sent: " + signal, Toast.LENGTH_SHORT);
        temp.show();
    }

    private void createList() {
        list = i.getBundleExtra("list");
        mStrings = new String[list.size() + 3];
        Iterator<String> m = list.keySet().iterator();

        for (int x = 0; m.hasNext(); x++) {
            mStrings[x] = list.getString(m.next());
        }

        mStrings[mStrings.length - 3] = "New " + i.getStringExtra("contains");
        mStrings[mStrings.length - 2] = "Help";
        mStrings[mStrings.length - 1] = "Back";
    }
    
    private void createDeviceList(String type) {
        list = i.getBundleExtra("list");
        codes = new Bundle();
        if (type.equals("TV") || type.equals("DVD")) {
            codes.putAll(ShortCuts.TVShortCuts);
            codes.putAll(ShortCuts.TVshortcutsChannel);
        } else if (type.equals("DVD") || type.equals("DVD")) {
            codes.putAll(ShortCuts.DVDshortcuts);
        } else if (type.equals("Stereo"))
            codes.putAll(ShortCuts.StearoShortcuts);       
        mStrings = new String[list.size() + codes.size() + 1];
        Iterator<String> m = list.keySet().iterator();
        int x;
        for (x = 0; m.hasNext(); x++) {
            mStrings[x] = list.getString(m.next());        
        }
        
        mStrings[++x] = "----------";
        
        m = codes.keySet().iterator();
        for ( ; m.hasNext(); x++) {
            String tag = m.next();
            mStrings[x] = tag + spaces(tag, codes.getString(tag)) + " ("+ codes.getString(tag) + ")";
        }
        
    }
    
    private String spaces (String tag, String shortcut) {
        int spaces = 30 - tag.length() - shortcut.length();
        String returnVal = "";
        for(int i = 0; i < spaces; i++) {
            returnVal = returnVal + "  ";
        }
        return returnVal;
    }
    
    public boolean onOptionsItemSelected(Menu.Item item) {
        switch (item.getId()) {
        case 0:
            Intent rename = new Intent(this, Edit.class);
            rename.putExtra("caller", i.getStringExtra("caller"));
            rename.putExtra("placement", -1);
            startSubActivity(rename, 0);
            return true;
        case 1:
            resultList.sendResult(Codes.DELETE, mStrings[getSelectedItemPosition()], null);
            list.remove(mStrings[getSelectedItemPosition()]);
            onCreate(null);
            return true;
        }
        return false;
    }

    protected void onActivityResult(int requestCode, int resultCode,
            String data, Bundle extras) {
        super.onActivityResult(requestCode, resultCode, data, extras);
        switch (resultCode) {
        case Codes.RENAME_OK:
            Bundle info = new Bundle();
            info.putString("old", mStrings[getSelectedItemPosition()]);
            info.putString("new", data);
            setResult(Codes.RENAME_MORE, null, info);
            mStrings[getSelectedItemPosition()] = data;
            viewList = new MoreListAdapter(this, mStrings);
            setListAdapter(viewList);
        }

    }

    public boolean onPrepareOptionsMenu(Menu menu) {
        super.onPrepareOptionsMenu(menu);
        menu.clear();

        if (mStrings[getSelectedItemPosition()].equals("New Location")
                || mStrings[getSelectedItemPosition()].equals("New Room")
                || mStrings[getSelectedItemPosition()].equals("New Device")
                || mStrings[getSelectedItemPosition()].equals("Back")) {
            return false;
        } else {
            menu.add(0, 0, "Rename");
            menu.add(0, 1, "Delete");
            return true;
        }
    }
    
    public boolean onKeyUp(int keyCode, KeyEvent event) {
        if (i.getStringExtra("caller").equals("device")) {
            if (i.getStringExtra("type").equals("TV") || i.getStringExtra("type").equals("Cable"))
                return ShortCuts.TVShortCuts(keyCode, event, this) || 
                    ShortCuts.TVShortCutsChannel(keyCode, event, this);
            if (i.getStringExtra("type").equals("DVD") || i.getStringExtra("type").equals("DVR"))
                return ShortCuts.DVDShortCuts(keyCode, event, this);
            if (i.getStringExtra("type").equals("Stereo"))
                return ShortCuts.stereoShortCuts(keyCode, event, this);
            return false;
        } else {
            return false;
        }
    }

    private String[] mStrings;
}
