package edu.berkeley.cs160.happytoastmobile.BorgTV.NineButton;

import android.content.Context;
import android.graphics.Color;
import android.view.View;
import android.view.ViewGroup;
import android.widget.BaseAdapter;
import android.widget.TextView;

/** A general List format that defines the More list.
 * 
 * @author Lita Cho
 *
 */
class MoreListAdapter extends BaseAdapter {
	/** Constructs the list depending on the activity and the 
	 *  contents.
	 * 
	 * @param context: The activity that is calling the adapter.
	 * @param strings: An array of strings that make up the list.
	 */
    public MoreListAdapter(Context context, String[] strings) {
        mContext = context;
        mStrings = strings;
    }

    public int getCount() {
        return mStrings.length;
    }

    public Object getItem(int position) {
        return position;
    }

    public long getItemId(int position) {
        return position;
    }

    /** getView controls what string is being selected along the cursor.*/
    public View getView(int position, View convertView, ViewGroup parent) {
        TextView tv;

        if (convertView == null) {
            tv = new TextView(mContext);
        } else {
            tv = (TextView) convertView;
        }
        tv.setTextColor(Color.WHITE);
        tv.setText(mStrings[position]);
        return tv;
    }

    private Context mContext;
    private String[] mStrings;
}
