package edu.berkeley.cs160.happytoastmobile.BorgTV.TVGuide;

import java.net.URL;
import java.util.Collections;
import java.util.Comparator;
import java.util.LinkedList;

import android.content.Context;
import android.view.View;
import android.view.ViewGroup;
import android.widget.BaseAdapter;


public class ChannelAdapter extends BaseAdapter{
	private LinkedList<ChannelView> channels;
	private Context context;
	
    public ChannelAdapter(Context c) {
        context = c;
        channels = new LinkedList<ChannelView>();
    }
	public Context getContext(){
		return context;
	}
	public int getCount() {
		return channels.size();
	}

	public Object getItem(int position) {
		return channels.get(position);
	}

	public long getItemId(int position) {
		return position;
	}

	public View getView(int position, View convertView, ViewGroup parent) {
		return channels.get(position);
	}
	public boolean areAllItemsSelectable(){
		return true;
	}
	
	public void addChannel(int chNo, String chName){
		ChannelView channel = new ChannelView(context, chNo, chName);
		//channel.setBackgroundColor(getCount() % 2 == 0 ? 0xff000000 : 0xff333333);
		channels.add(channel);
	}
	public void addChannel(ChannelView channel){
		channels.add(channel);
	}
	public int getChannelIndex(ChannelView channel){
		return channels.indexOf(channel);
	}
	public void sortNameAscending(){
		Comparator<ChannelView> c = new Comparator<ChannelView>(){
			public int compare(ChannelView cv1, ChannelView cv2) {
				return	cv1.getName().compareTo(cv2.getName());
			}			
		};
		Collections.sort(channels, c);
		//channels.
	}
	public void sortNameDescending(){
		Comparator<ChannelView> c = new Comparator<ChannelView>(){
			public int compare(ChannelView cv1, ChannelView cv2) {
				return	cv2.getName().compareTo(cv1.getName());
			}			
		};
		Collections.sort(channels, c);
		//channels.
	}
	public void sortNumberAscending(){
		Comparator<ChannelView> c = new Comparator<ChannelView>(){
			public int compare(ChannelView cv1, ChannelView cv2) {
				return	cv1.getNumber() - cv2.getNumber();
			}			
		};
		Collections.sort(channels, c);
		//channels.
	}
	public void sortNumberDescending(){
		Comparator<ChannelView> c = new Comparator<ChannelView>(){
			public int compare(ChannelView cv1, ChannelView cv2) {
				return	cv2.getNumber() - cv1.getNumber();
			}			
		};
		Collections.sort(channels, c);
		//channels.
	}
	
	public int findChannelByName(String name){
		for (int i = 0; i < channels.size(); i++){
			if(channels.get(i).getName().equals(name)){
				return i;
			}
		}
		return -1;
	}
}