package edu.berkeley.cs160.happytoastmobile.BorgTV.TVGuide;

import java.util.LinkedList;

import android.util.Log;
import android.content.Context;
import android.graphics.Canvas;
import android.graphics.ColorFilter;
import android.graphics.drawable.Drawable;
import android.graphics.drawable.GradientDrawable;
import android.graphics.drawable.GradientDrawable.Orientation;
import android.text.Layout.Alignment;
import android.util.AttributeSet;
import android.view.KeyEvent;
import android.widget.Gallery;
import android.widget.LinearLayout;
import android.widget.TextView;


public class ChannelView extends LinearLayout{
	
	private int channelNumber;
	private String channelName;
	private Gallery showGallery;
	private int pixWidth = 50;
	private int pixHeight = 35;
	private TextView channelInfo;
	public ChannelView(Context context, int chNo, String chName) {
		super(context);
		this.setFocusable(false);
		this.setLayoutParams(new LayoutParams(LayoutParams.FILL_PARENT, pixHeight));
		channelName = chName;
		channelNumber = chNo;
		setOrientation(HORIZONTAL);
		channelInfo = new TextView(context);
		channelInfo.setText(channelName + "\n" + channelNumber);
		channelInfo.setAlignment(Alignment.ALIGN_OPPOSITE);
		channelInfo.setBackgroundColor(0xff000088);
		channelInfo.setFocusable(false);
		addView(channelInfo, new LayoutParams(pixWidth, pixHeight));
		showGallery = new Gallery(context){
			 @Override 
			 public boolean onKeyDown(int keyCode, KeyEvent event){
				 super.onKeyDown(keyCode, event);
				 //Log.e("BorgTV Guide","Key down in gallery");
				 return false;
			 }
		};
		showGallery.setDrawSelectorOnTop(false);
		//showGallery.setLayoutParams(new LayoutParams(LayoutParams.FILL_PARENT, 25));
		//showGallery.setBackgroundColor(0xffffffff);
		showGallery.setLayoutParams(new LayoutParams(LayoutParams.FILL_PARENT, pixHeight));
		showGallery.setFadingEdgeLength(30);
		showGallery.setSpacing(2);
		showGallery.setFocusable(true);
		showGallery.setFocusType(WEAK_FOCUS);
		showGallery.setFocusableInTouchMode(false);
		ShowAdapter sAdapter = new ShowAdapter(context, 48, channelName);
		/*sAdapter.addShow(new Show("Show #1", 1230, 30));
		sAdapter.addShow(new Show("Show #2", 1330, 30));
		sAdapter.addShow(new Show("Show #3", 1630, 60));
		sAdapter.addShow(new Show("Show #4", 1530, 60));
		*/
		//int colors[] = {0x20ff6600, 0x50ff6600,};
		//showGallery.setSelectorSkin(new GradientDrawable(Orientation.LEFT_RIGHT, colors));
		showGallery.setAdapter(sAdapter);
		showGallery.setSelected(false);
		showGallery.setClipChildren(false);
		
		addView(showGallery);
	}
	public void setNumber(int number){
		this.channelNumber = number;
		channelInfo.setText(channelName + "\n" + channelNumber);
	}
	
	public void setName(String name){
		this.channelName = name;
		channelInfo.setText(channelName + "\n" + channelNumber);
	}
	public String getName(){
		return this.channelName;
	}
	public int getNumber(){
		return this.channelNumber;
	}
	@Override 
	public boolean onKeyDown(int keyCode, KeyEvent event){
		//Log.e("BorgTV Guide", "Key down in channel view");
		return true;
	}
	
	public void setSelection(int position){
		showGallery.setSelection(position, true);
		showGallery.setSelected(false);
	}
	public ShowAdapter getShowAdapter(){
		return (ShowAdapter) showGallery.getAdapter();
	}
}
