package edu.berkeley.cs160.happytoastmobile.BorgTV.TVGuide;

import org.xml.sax.Attributes; 
import org.xml.sax.SAXException; 
import org.xml.sax.helpers.DefaultHandler; 

import android.widget.Gallery;


public class GuideXMLHandler extends DefaultHandler{ 

     // =========================================================== 
     // Fields 
     // =========================================================== 
      
     private boolean inListings = false; 
     private boolean inChannel = false; 
     private boolean inShow = false; 
      
     private ChannelAdapter channelAdapter;
     private ChannelView currentChannel;
     private Show currentShow;
     
     private GuideDbAdapter databaseAdapter;
     
     public GuideXMLHandler(ChannelAdapter cAdapter, GuideDbAdapter dbAdapter){
    	 channelAdapter = cAdapter;
    	 databaseAdapter = dbAdapter;
     }
     

     // =========================================================== 
     // Methods 
     // =========================================================== 
     @Override 
     public void startDocument() throws SAXException { 
    	 // meh
     } 

     @Override 
     public void endDocument() throws SAXException { 
          // Nothing to do 
     } 

     /** Gets be called on opening tags like: 
      * <tag> 
      * Can provide attribute(s), when xml was like: 
      * <tag attribute="attributeValue">*/ 
     @Override 
     public void startElement(String namespaceURI, String localName, 
               String qName, Attributes atts) throws SAXException { 
         if (localName.equals("listing")) { 
            this.inListings = true; 
        }else if (localName.equals("channel")) { 
        	this.inChannel = true;
            String name = atts.getValue("name");
            int number = Integer.parseInt(atts.getValue("number"));
            this.currentChannel = new ChannelView(channelAdapter.getContext(), number, name);
        }else if (localName.equals("show")) { 
            this.inShow = true; 
            String name = atts.getValue("name");
            int startTime = Integer.parseInt(atts.getValue("startTime"));
            int duration = Integer.parseInt(atts.getValue("duration"));
            String description = atts.getValue("description");
            this.currentShow = new Show(name, startTime, duration);
            currentShow.setChannelName(currentChannel.getName());
            currentShow.setDescription(description);
        }
     } 
      
     /** Gets be called on closing tags like: 
      * </tag> */ 
     @Override 
     public void endElement(String namespaceURI, String localName, String qName) 
               throws SAXException { 
          if (localName.equals("listing")) { 
               this.inListings = false; 
          }else if (localName.equals("channel")) {
        	   channelAdapter.addChannel(currentChannel);
        	   ((Gallery) currentChannel.getChildAt(1)).setAllowWrap(true);
        	   currentChannel.setSelection(TVGuide.getCurrentTimeIndex());
        	   currentChannel = null;
               this.inChannel = false; 
          }else if (localName.equals("show")) {
        	   currentChannel.getShowAdapter().addShow(currentShow);

        	   // Trying adding _all_ shows.
        	   if (!databaseAdapter.containsShow(currentShow))
        		   databaseAdapter.addShow(currentShow, false, false, false);
        	   
        	   if (databaseAdapter.getFavorite(currentShow)){
        		   currentShow.setNormalColor(Show.FAVORITE_COLOR);
        	   }
        	   currentShow = null;
               this.inShow = false; 
          }
     } 
      
     /** Gets be called on the following structure: 
      * <tag>characters</tag> */ 
     @Override 
    public void characters(char ch[], int start, int length) { 
          // do nothing
    } 
}