package edu.berkeley.cs160.happytoastmobile.BorgTV.TVGuide;


import edu.berkeley.cs160.happytoastmobile.BorgTV.R;
import edu.berkeley.cs160.happytoastmobile.BorgTV.NineButton.Codes;
import edu.berkeley.cs160.happytoastmobile.BorgTV.NineButton.Help;
import android.app.Activity;
import android.app.ListActivity;
import android.content.Intent;
import android.database.Cursor;
import android.os.Bundle;
import android.util.Log;
import android.view.View;
import android.widget.CursorAdapter;
import android.widget.ListView;
import android.widget.SimpleCursorAdapter;
import android.widget.Toast;

public class ListGuide extends ListActivity{
	private int queryType;
	private GuideDbAdapter dbAdapter;
	
	private int FAVORITES = 0;
	private int REMINDERS = 1;
	private int SEARCH = 2;
	
	public void onCreate(Bundle icicle) {
		super.onCreate(icicle);
		
		Intent i = this.getIntent();
		String type = i.getStringExtra("type");
		Cursor c;
		Toast toast;
		dbAdapter = new GuideDbAdapter(this);
        dbAdapter.open();
        
		if (type.equals("favorite")){
			queryType = FAVORITES;
			c = dbAdapter.getFavoritesCursor();
			setTitle("BorgTV Guide: Favorites");
			if (c == null){
				toast = Toast.makeText(this, "No shows have been marked as favorites.", Toast.LENGTH_SHORT);
				toast.show();
	        	dbAdapter.close();
	        	finish();
	        	return;
			}
		} else if (type.equals("reminder")){
			queryType = REMINDERS;
			c = dbAdapter.getRemindersCursor();
			setTitle("BorgTV Guide: Reminder");
			if (c == null){
				toast = Toast.makeText(this, "You have no upcoming show reminders.", Toast.LENGTH_SHORT);
				toast.show();
	        	dbAdapter.close();
	        	finish();
	        	return;
			}
		} else if (type.equals("search")){
			queryType = SEARCH;
			String query = i.getStringExtra("name");
			c = dbAdapter.getAiringsByName(query);
			setTitle("BorgTV Guide: Search \"" + query + "\"");
			if (c == null){
				toast = Toast.makeText(this, "No shows match that name.", Toast.LENGTH_SHORT);
				toast.show();
	        	dbAdapter.close();
	        	finish();
	        	return;
			}
		} else {
			c = null;
			finish();
			return;
		}
		
        
        /*for (int j = 0; j < c.getColumnNames().length; j++){
            Log.e("listguide", c.getColumnName(j));
        }*/
        SimpleCursorAdapter ca = new SimpleCursorAdapter(this, R.layout.guidelistentry, c,
        		new String[]{GuideDbAdapter.KEY_ROWID, GuideDbAdapter.KEY_TITLE, GuideDbAdapter.KEY_HUMANTIME,
        					GuideDbAdapter.KEY_CHANNELNAME, GuideDbAdapter.KEY_DURATION},
        		new int[]{R.id.showDuration, R.id.showTitle, R.id.showTime, R.id.channelName}
        );
        this.getListView().setBackgroundColor(0xff000000);
        
        this.setListAdapter(ca);        
    }
	
	protected void onListItemClick(ListView l, View v, int position, long id) {    
		Cursor c = ((SimpleCursorAdapter)l.getAdapter()).getCursor();
		Bundle extras = new Bundle();
		extras.putInt("time", c.getInt(c.getColumnIndex(GuideDbAdapter.KEY_TIME)));
		extras.putString("channel", c.getString(c.getColumnIndex(GuideDbAdapter.KEY_CHANNELNAME)));
		this.setResult(Activity.RESULT_OK, "", extras);
		dbAdapter.close();
		finish();
    }
	
}