package edu.berkeley.cs160.happytoastmobile.BorgTV.TVGuide;

import java.util.LinkedList;
import java.util.ListIterator;

import android.widget.TextView;

public class Show {
	private String title;
	private int startTime; // military time, 1330 = 1:30pm
	private int duration;
	private LinkedList<TextView> views;
	private String description;
	private String channelName;
	private boolean highlighted;
	private int normalColor;
	private int highlightColor;
	
	public static int NORMAL_COLOR = 0xff003333;
	public static int NORMAL_HIGHLIGHT = 0xffcc6600;
	public static int EMPTY_COLOR = 0xff555555;
	public static int FAVORITE_COLOR = 0xffcc0033;
	public static int TIME_COLOR = 0xff330066;
	
	public Show(String name, int start, int length){
		title = name;
		startTime = start;
		duration = length;
		normalColor = NORMAL_COLOR;
		highlightColor = NORMAL_HIGHLIGHT;
		highlighted = false;
		views = new LinkedList<TextView>();
	}
		

	
	public int getNormalColor(){
		return normalColor;
	}
	
	public void setNormalColor(int color){
		normalColor = color;
		setHighlight(highlighted);
	}
	
	public void addView(TextView tv){
		tv.setText(title);
		tv.setBackgroundColor(highlighted ? highlightColor : normalColor);		
		views.add(tv);
	}
	
	
	public void setHighlight(boolean newHighlight){
		highlighted = newHighlight;
		ListIterator<TextView> iter = views.listIterator();
		while(iter.hasNext()){
			iter.next().setBackgroundColor(highlighted ? highlightColor : normalColor);
		}
	}

	public String getTitle() {
		return title;
	}


	public void setTitle(String title) {
		this.title = title;
	}


	public int getStartTime() {
		return startTime;
	}


	public void setStartTime(int startTime) {
		this.startTime = startTime;
	}


	public int getDuration() {
		return duration;
	}


	public void setDuration(int duration) {
		this.duration = duration;
	}


	public String getDescription() {
		return description;
	}


	public void setDescription(String description) {
		this.description = description;
	}


	public String getChannelName() {
		return channelName;
	}


	public void setChannelName(String channelName) {
		this.channelName = channelName;
	}

	public TextView getView(int i) {
		return views.get(i);
	}
	
}