package edu.berkeley.cs160.happytoastmobile.BorgTV.TVGuide;

import java.net.URL;
import java.util.LinkedList;

import android.content.Context;
import android.view.View;
import android.view.ViewGroup;
import android.widget.BaseAdapter;
import android.widget.Button;
import android.widget.TextView;


public class ShowAdapter extends BaseAdapter{
	private LinkedList<Show> shows;
	private LinkedList<View> views;
	private Context context;
	private int lineHeight = 35;
	private int halfHourWidth = 110;
	
    public ShowAdapter(Context c, int size, String channelName) {
        context = c;
        shows = new LinkedList<Show>();
        views = new LinkedList<View>();
        
        for (int i = 0; i < size; i++){
        	Show emptyShow = new Show("No Show Info", (i/2)*100 + (i%2)*30, 30);
        	emptyShow.setNormalColor(0xff555555);
        	TextView emptyView = new TextView(context);
        	emptyShow.setDescription("Sorry, no show information is available.");
			emptyView.setHeight(lineHeight);
			emptyView.setWidth(halfHourWidth);
			emptyShow.setChannelName(channelName);
			
        	views.add(emptyView);
        	emptyShow.addView(emptyView);
        	shows.add(emptyShow);
        }
    }
	
	public int getCount() {
		return views.size();
	}

	public Object getItem(int position) {
		return shows.get(position);
	}

	public long getItemId(int position) {
		return position;
	}

	public View getView(int position, View convertView, ViewGroup parent) {
		TextView view;
		if (position >= views.size() || position < 0){
			view = new TextView(context);
			view.append("No Show Info");
			view.setHeight(lineHeight);
			view.setWidth(halfHourWidth);
			view.setBackgroundColor(0xff555555);
		} else {
			view = (TextView) views.get(position);
		}
		return view;
	}
	
	public boolean areAllItemsSelectable(){
		return false;
	}
	
	public static int startTimeToIndex(int time){
		int result = time/50 + ((time%100)/30);
		return result;
	}
	
	public void addShow(Show newShow){
		for (int i = 0; i < newShow.getDuration()/30; i++){
			shows.set(startTimeToIndex(newShow.getStartTime()) + i, newShow);
			newShow.addView((TextView) views.get(startTimeToIndex(newShow.getStartTime()) + i));
		}
		
		/*TextView show = new TextView(context);
		
		
		show.append(title);
		show.setHeight(lineHeight);
		show.setWidth(halfHourWidth);
		//show.setBackgroundColor(getCount() % 2 == 0 ? 0xff003300 : 0xff003333);
		show.setBackgroundColor(0xff003333);
		//show.setFocusable(true);
		shows.add(show);*/
		
	}
}