package edu.berkeley.cs160.happytoastmobile.BorgTV.TVGuide;

import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.FileOutputStream;
import java.io.InputStream;
import java.net.URL;
import java.util.Calendar;

import edu.berkeley.cs160.happytoastmobile.BorgTV.R;
import android.app.Activity;
import android.app.ProgressDialog;
import android.content.Context;
import android.content.Intent;
import android.graphics.drawable.GradientDrawable;
import android.graphics.drawable.GradientDrawable.Orientation;
import android.os.Bundle;
import android.os.Handler;
import android.os.Message;
import android.text.method.KeyCharacterMap;
import android.util.Log;
import android.view.Gravity;
import android.view.KeyEvent;
import android.view.Menu;
import android.view.Menu.Item;
import android.view.Menu.OnClickListener;
import android.widget.Gallery;
import android.widget.LinearLayout;
import android.widget.ListView;
import android.widget.TextView;
import android.widget.Toast;
import android.widget.LinearLayout.LayoutParams;


import javax.xml.parsers.DocumentBuilder;
import javax.xml.parsers.DocumentBuilderFactory;
import javax.xml.parsers.ParserConfigurationException;
import javax.xml.parsers.SAXParser;
import javax.xml.parsers.SAXParserFactory;

import org.w3c.dom.Document;
import org.xml.sax.InputSource;
import org.xml.sax.XMLReader;
import org.xml.sax.helpers.DefaultHandler;

public class TVGuide extends Activity{
	
	private int focusedChannel;
	private int focusedTime;
	private ListView channelListView;
	private Gallery timeGallery;
	private ChannelAdapter channelAdapter;
	private GuideDbAdapter dbAdapter;
	
	private int sortField;
	private int sortOrder;
	
	private static int NUMBER = 0;
	private static int NAME = 1;
	private static int ASCENDING = 0;
	private static int DESCENDING = 1;
	
	private static int FIELD = 1;
	private static int ORDER = 2;
	
	//private static String listingURL = "http://litacho1.googlepages.com/listings.xml";
	//private static String listingURL =  "http://www.eecs.berkeley.edu/~djacobs/cs160/listings.xml";
	//private static String listingURL =  "http://www.ocf.berkeley.edu/~djacobs/cs160/listings2.xml";
	private static String listingURL =  "http://www.ocf.berkeley.edu/~djacobs/cs160/combinedListing.xml";
	
	private static int SHOW_INFO = 0;
	private static int PROGRESS_WHEEL = 1;
	private static int LIST_GUIDE = 2;
	private static int SEARCH_DIALOG = 3;
	
	private Activity me;
	
	private Handler handler = new Handler(){
		@Override
        public void handleMessage(Message msg) {
			for (int i = 0; i < channelAdapter.getCount(); i++){
				ChannelView cv = (ChannelView) channelAdapter.getView(i, null, null);
				((ShowAdapter) ((Gallery) cv.getChildAt(1)).getAdapter()).notifyDataSetChanged();
			}
			channelAdapter.notifyDataSetChanged(); 			
			updateSelection();
			
		}
	};
	
	
	private ProgressDialog myProgressDialog;
    /** Called when the activity is first created. */
    @Override
    public void onCreate(Bundle icicle) {
        super.onCreate(icicle);
        me = this;
        me.setContentView(R.layout.guide);
    	
       // Intent intent = new Intent (this, LoadingGuide.class);
    	//this.startSubActivity(intent, PROGRESS_WHEEL);
    	
        /*Thread t = new Thread() { 
		    public void run() { 
		         try{ 
		        	 Log.e("Threadballs", "thread is running, bitcho");
		        	 sleep(5); 
		             ((ProgressDialog)null).dismiss();
		        	 myProgressDialog.dismiss(); 
		             
		         } catch (Exception e) {  } 
		    } 
		};
		t.start(); */
        
        myProgressDialog = ProgressDialog.show(this, 
                "Please wait...", "Loading channel listings...", true); 
        
        timeGallery = new Gallery(me){
			 @Override 
			 public boolean onKeyDown(int keyCode, KeyEvent event){
				 super.onKeyDown(keyCode, event);
				 //Log.e("BorgTV Guide","Key down in gallery");
				 return false;
			 }
		};
       	
       //(Gallery) findViewById(R.id.timeGallery);
       timeGallery.setFadingEdgeLength(30);
       timeGallery.setSpacing(2);
       timeGallery.setFocusableInTouchMode(false);
       ShowAdapter sAdapter = new ShowAdapter(me, 48, "Time");
       for (int i = 0; i < 48; i++){
       		int hour = (i/2) % 12;
	       	hour = (hour == 0) ? 12 : hour;
	       	String meridian = (i/2 < 12) ? new String("am") : new String("pm");
	       	String minute = i%2 == 0 ? new String("00") : new String("30");
	       	
	       	Show time = new Show(hour + ":" +  minute + meridian, ((i/2)*100+(i%2)*30) , 30);
	       	time.setNormalColor(Show.TIME_COLOR);
	       	sAdapter.addShow(time);
       }
		
		timeGallery.setAdapter(sAdapter);
		timeGallery.setGravity(Gravity.BOTTOM);
		timeGallery.setAllowWrap(true);
		LinearLayout header = (LinearLayout) findViewById(R.id.guideHeader);
		header.addView(timeGallery, new LayoutParams(LayoutParams.FILL_PARENT, LayoutParams.WRAP_CONTENT));
	   
       channelListView = (ListView) findViewById(R.id.channelList);
       //int colors[] = {0xffff0000, 0xff00ff00, 0xff0000ff};
       int colors[] = {0xff000000, 0xff000000};
       
       channelListView.setDivider(new GradientDrawable(Orientation.LEFT_RIGHT, colors));
       channelListView.setDividerHeight(2);
       channelListView.setFadingEdgeLength(30);
       channelListView.setDrawingCacheEnabled(false);
       
       channelListView.setFocusable(false);
       //setFocusType(android.view.View.NORMAL_FOCUS);
       
       channelAdapter = new ChannelAdapter(me);
       channelListView.setAdapter(channelAdapter);
      
       sortField = NUMBER;
       sortOrder = ASCENDING;
       
       Thread t = new Thread(new Runnable(){
    	   public void run() { 
    	    	dbAdapter = new GuideDbAdapter(me);
    	        dbAdapter.open();
    	        
    	        //ChannelAdapter chAdapter = new ChannelAdapter(me);
    	        
    	        /*chAdapter.addChannel(7, "ABC");
    	        chAdapter.addChannel(8, "NBC");
    	        chAdapter.addChannel(9, "Fox");
    	        chAdapter.addChannel(10, "Com");
    	        chAdapter.addChannel(11, "USA");
    	        chAdapter.addChannel(12, "WGN");
    	        chAdapter.addChannel(13, "Scifi");
    	        chAdapter.addChannel(14, "Disc");
    	        chAdapter.addChannel(15, "Animal");
    	        chAdapter.addChannel(16, "TLC");
    	        chAdapter.addChannel(17, "Sci");
    	        chAdapter.addChannel(18, "Spike");*/
    	        
    	        //channelAdapter = chAdapter;
    	        loadGuide();
    	        
    	        
    	        
    	        focusedTime = getCurrentTimeIndex();
    	        
    	        focusedChannel = channelAdapter.getCount()/2;
    	        
    	        channelAdapter.sortNumberAscending();
    	        
    	        //channelAdapter.notifyDataSetChanged();
    	        
    	        //updateSelection();            
    	    	
    	    	myProgressDialog.dismiss(); 
    	    	handler.sendEmptyMessage(0);
    	   }
       });
       t.start(); 
       
       
       
        // I have no idea how to make this actually work.
        if (icicle != null){
        	if (icicle.containsKey("channel")){
        		focusedChannel = icicle.getInt("channel");
        	}
        	if (icicle.containsKey("time")){
        		focusedTime = icicle.getInt("time");
        	}
        }
    	
        //setContentView(R.layout.guide);
        
    }
    
    public GuideDbAdapter getDbAdapter(){
    	return dbAdapter;
    }
        
    @Override
    public void onResume() {
    	super.onResume();
    	//Log.e("Guide", "totally in on-resume");
    	//This is craziness
    }
    
    @Override
    public void onFreeze(Bundle icicle){
    	icicle.putInt("channel", focusedChannel);
    	icicle.putInt("time",focusedTime);
    }
    
    protected void loadGuide(){
        try { 
             /* Create a URL we want to load some xml-data from. */ 
	        // InputSource is = new InputSource();
        	InputStream fis;
        	String filename = "new_random_word_listings" + getCurrentDate() + ".xml";
        	try {
        		fis = super.openFileInput(filename);
        	} catch (FileNotFoundException e){
        		URL url = new URL(listingURL);
        		FileOutputStream fos = super.openFileOutput(filename, super.MODE_PRIVATE);
        		fis = url.openStream();
        		byte bytes[] = new byte[1024];
        		int n;
        		while ((n = fis.read(bytes)) != -1){
        			fos.write(bytes);
        		}
        		fos.close();
        		fis.close();
        		fis = super.openFileInput(filename);
        	}
        	
	        
        	//URL url = new URL(listingURL);
	         //URL url = new URL("http://192.168.1.103/~djacobs/listings.xml"); 
	         
	         /* Get a SAXParser from the SAXPArserFactory. */ 
             SAXParserFactory spf = SAXParserFactory.newInstance(); 
             SAXParser sp = spf.newSAXParser(); 

             /* Get the XMLReader of the SAXParser we created. */ 
             XMLReader xr = sp.getXMLReader(); 
             /* Create a new ContentHandler and apply it to the XML-Reader*/ 
             //ExampleHandler myExampleHandler = new ExampleHandler(); 
             GuideXMLHandler handler = new GuideXMLHandler(channelAdapter, dbAdapter);
             xr.setContentHandler(handler); 
              
             /* Parse the xml-data from our URL. */ 
             //xr.parse(new InputSource(url.openStream())); 
             xr.parse(new InputSource(fis)); 
             
             /* Parsing has finished. */ 
             
                        
        } catch (Exception e) { 
             /* Display any Error to the GUI. */
             Log.e("BorgTV Guide", "Problems reading XML"); 
             
        } 
    	
    }
    
    
    
    protected void updateSelection(){
    	//this.setTitle("ch:" + focusedChannel + " time:" + focusedTime);
    	timeGallery.setSelection(focusedTime, true);
    	timeGallery.setSelected(false);
    	channelListView.setSelection(focusedChannel);
    	for (int i = 0; i < channelListView.getCount(); i++){
    		ChannelView channel = (ChannelView) channelListView.getAdapter().getView(i, null,null);
    		channel.setSelection(focusedTime);
    		/*if (i == focusedChannel){
    			TextView cell = (TextView) ((Gallery) channel.getChildAt(1)).getAdapter().getView(focusedTime, null , null);
    			cell.setBackgroundColor(0xffcc6600);
    		}*/
    	}
    	getSelectedShow().setHighlight(true);
    	
    }
    
    protected Show getSelectedShow(){
    	ChannelView channel = (ChannelView) channelListView.getAdapter().getView(focusedChannel, null,null);
    	return ((Show) ((Gallery) channel.getChildAt(1)).getAdapter().getItem(focusedTime));
    }
    protected ChannelView getSelectedChannel(){
    	ChannelView channel = (ChannelView) channelListView.getAdapter().getView(focusedChannel, null,null);
    	return channel;
    }
    
    @Override 
    public boolean onKeyDown(int keyCode, KeyEvent event){
    	KeyCharacterMap keyMap = KeyCharacterMap.load(event.getDeviceId()); 
    	// if you start typing, assume it's a search request
    	//Log.e("BorgTV Guide", "Key down in guide");
    	//ChannelView channel = (ChannelView) channelListView.getAdapter().getView(focusedChannel, null,null);
    	//TextView cell = (TextView) ((Gallery) channel.getChildAt(1)).getAdapter().getView(focusedTime, null , null);
		//cell.setBackgroundColor(0xff003333);
		int page = 1;
    	if (event.isAltPressed()){
			page = 2;
		}
    	if (keyMap.isPrintingKey(keyCode)){
    		char[] chars = new char[6];
    		//keyMap.getMatch(keyCode, chars);
    		//launchSearchDialog(chars[0]);
    		launchSearchDialog(keyMap.getDisplayLabel(keyCode));
    	}
    	else switch (keyCode){
    	case KeyEvent.KEYCODE_BACK:
    		finish();
    		break;
    	case KeyEvent.KEYCODE_SOFT_LEFT:
    		openOptionsMenu();
    		break;
    	case KeyEvent.KEYCODE_DPAD_CENTER:
    	case KeyEvent.KEYCODE_NEWLINE:
    	case KeyEvent.KEYCODE_SPACE:
    		launchShowInfo();
			//openOptionsMenu(); 
    		break;
    		// change pages with the up and down arrow keys
    	case KeyEvent.KEYCODE_DPAD_UP:
    		getSelectedShow().setHighlight(false);
    		focusedChannel = Math.max(0, focusedChannel - page);
    		break;
    	case KeyEvent.KEYCODE_DPAD_DOWN:
    		getSelectedShow().setHighlight(false);
    		focusedChannel = Math.min(channelListView.getAdapter().getCount() - 1, focusedChannel+page);
    		break;
    	case KeyEvent.KEYCODE_DPAD_LEFT:
    		getSelectedShow().setHighlight(false);
    		focusedTime = Math.max(0, focusedTime - page);
    		break;
    	case KeyEvent.KEYCODE_DPAD_RIGHT:
    		getSelectedShow().setHighlight(false);
    		focusedTime = Math.min(timeGallery.getAdapter().getCount() - 1, focusedTime+page);
    		break;
    	}
    	
    	
    	
		
    	updateSelection();
    	// let the gallery handle the other key events
    	return true;
    }
    
    public void launchShowInfo(){
    	// set up the intent to launch the search dialog. 
    	Intent intent = new Intent();
		intent.setAction("edu.berkeley.cs160.happytoastmobile.BorgTV.ShowInfo");
		Show show = getSelectedShow();
		ChannelView channel = getSelectedChannel();
		
		intent.putExtra("channelName", channel.getName());
		intent.putExtra("channelNumber", channel.getNumber());
		intent.putExtra("title", show.getTitle());
		intent.putExtra("startTime", show.getStartTime());
		intent.putExtra("duration", show.getDuration());
		intent.putExtra("description", show.getDescription());
		
		intent.putExtra("favorite", dbAdapter.getFavorite(show));
		intent.putExtra("reminder", dbAdapter.getReminder(show));
		intent.putExtra("recurringReminder", dbAdapter.getRecurringReminder(show));
		
		// pass the current search tag to the subactivity
		//TextView tag = (TextView) findViewById(R.id.searchTag);
		//intent.putExtra("edu.berkeley.cs160.djacobs.searchTag", tag.getText().toString());
		// start it up
		startSubActivity(intent, SHOW_INFO);
    }
    
    static int getCurrentTimeIndex(){
    	Calendar currentTime = Calendar.getInstance();
        currentTime.setTimeInMillis(System.currentTimeMillis());
        int hour = currentTime.get(Calendar.HOUR_OF_DAY);
        int minute = currentTime.get(Calendar.MINUTE);
        return ShowAdapter.startTimeToIndex(hour*100 + minute);
    }
    
    static int getCurrentDate(){
    	Calendar currentTime = Calendar.getInstance();
        currentTime.setTimeInMillis(System.currentTimeMillis());
        int year = currentTime.get(Calendar.YEAR);
        int month = currentTime.get(Calendar.MONTH);
        int day = currentTime.get(Calendar.DAY_OF_MONTH);        
        return year*10000 + month*100 + day;
    }
    
    @Override
    protected void onActivityResult(int requestCode, int resultCode,
            						String data, Bundle extras){
    	Show show = getSelectedShow();
    	if (requestCode == SHOW_INFO){
    		if (resultCode == RESULT_OK && getCurrentTimeIndex() == focusedTime){
    			// this means we are watching that shit.
    		} else if (resultCode == RESULT_OK){
    			boolean reminder, recurring, favorite;
    			reminder = extras.getBoolean("reminder");
    			recurring = extras.getBoolean("recurringReminder");
    			favorite = extras.getBoolean("favorite");
    			boolean interesting = reminder || recurring || favorite;
    			if (dbAdapter.containsShow(show)){
    				//if (interesting){
    					dbAdapter.setReminder(show, reminder);
    					dbAdapter.setRecurringReminder(show, recurring);
    					dbAdapter.setFavorite(show, favorite);
    				//} else {
    					// Don't kill shows... experimenting.
    					//dbAdapter.killShow(show);
    				//}
    			} else if (interesting){
    				dbAdapter.addShow(show, favorite, reminder, recurring);
    			}
    			show.setNormalColor(extras.getBoolean("favorite") ? Show.FAVORITE_COLOR : Show.NORMAL_COLOR);
    		}
    		if (resultCode == RESULT_CANCELED){
    			// just wanted info
    		}
    	} else if (requestCode == LIST_GUIDE && resultCode == RESULT_OK){
    		getSelectedShow().setHighlight(false);
    		focusedChannel = channelAdapter.findChannelByName(extras.getString("channel"));
    		focusedTime = ShowAdapter.startTimeToIndex(extras.getInt("time"));
    		updateSelection();
    		launchShowInfo();
    	} else if (requestCode == SEARCH_DIALOG && resultCode == RESULT_OK){
    		launchSearch(data);
    	}
    	
    }
    
    public void sortChannels(){
    	TextView sort = (TextView) findViewById(R.id.channelSort);
		ChannelView ch = (ChannelView) channelAdapter.getItem(focusedChannel);
    	if (sortField == NUMBER){
    		if (sortOrder == ASCENDING){
    			channelAdapter.sortNumberAscending();
    			sort.setText("Ch\n0-9");
    		} else {
    			channelAdapter.sortNumberDescending();
    			sort.setText("Ch\n9-0");
    		}
    	} else {
    		if (sortOrder == ASCENDING){
    			channelAdapter.sortNameAscending();
    			sort.setText("Ch\nA-Z");
    		} else {
    			channelAdapter.sortNameDescending();
    			sort.setText("Ch\nZ-A");
    		}
    	}
    	focusedChannel = channelAdapter.getChannelIndex(ch);
		channelAdapter.notifyDataSetChanged();
		updateSelection();
    }
    
	@Override
	public boolean onCreateOptionsMenu(Menu menu){
		
		// Create the menu Items.
		// More on these in their subfunctions. 
		final Item sortType = menu.add(0, FIELD, "Sort Name"); // Launch the search dialog
		final Item sortOrd = menu.add(0, ORDER, "Flip Order"); // Launch the search dialog
		
		final Item favorites = menu.add(0, 0, "Favs"); // Launch the search dialog
		favorites.setIcon(R.drawable.heart);
		final Item reminders = menu.add(0, 0, "Alarms"); // Launch the search dialog
		reminders.setIcon(R.drawable.bell1);
		final Item search = menu.add(0, 0, "Search"); // Launch the search dialog
		search.setIcon(R.drawable.search);
		// Build the menu listener
		OnClickListener menuListener = new OnClickListener() {
			public boolean onClick(Item i) {
				if (i == favorites){
					launchFavorites();
					return false;
				} else if (i == reminders){
					launchReminders();
					return false;
				} else if (i == sortType){
					sortField = (sortField == 0) ? 1 : 0;
					sortChannels();
				} else if (i == sortOrd){
					sortOrder = (sortOrder == 0) ? 1 : 0;
					sortChannels();
				} else if (i == search){
					launchSearchDialog('\0');
					//launchSearch("Scrubs");
					return false;
				}
				return false;
			}
		};
		
		// Set the listener for all the guys
		sortType.setClickListener(menuListener);
		sortOrd.setClickListener(menuListener);
		favorites.setClickListener(menuListener);
		reminders.setClickListener(menuListener);
		search.setClickListener(menuListener);
		
		return true;
	}
	
	public boolean onPrepareOptionsMenu(Menu menu){
		
		Item field = menu.get(menu.findItemIndex(FIELD));
		Item order = menu.get(menu.findItemIndex(ORDER));
		/*switch (sortField << 1 + sortOrder){
		case 0:
			field.setTitle("Sort A-Z");
			order.setTitle("Sort 9-0");
			break;
		case 1:
			field.setTitle("Sort Z-A");
			order.setTitle("Sort 0-9");
			break;
		case 2:
			field.setTitle("Sort 0-9");
			order.setTitle("Sort Z-A");
			break;
		case 3:
			field.setTitle("Sort 9-0");
			order.setTitle("Sort A-Z");
			break;
		}*/
		field.setTitle((sortField == NUMBER) ? "ChName Sort" : "ChNum Sort");
		return super.onPrepareOptionsMenu(menu);
	}
	
	void launchFavorites(){
    	Intent intent = new Intent();
		intent.setAction("edu.berkeley.cs160.happytoastmobile.BorgTV.ListGuide");
		intent.putExtra("type", "favorite");
		startSubActivity(intent, LIST_GUIDE);
	}
	
	void launchReminders(){
    	Intent intent = new Intent();
		intent.setAction("edu.berkeley.cs160.happytoastmobile.BorgTV.ListGuide");
		intent.putExtra("type", "reminder");
		startSubActivity(intent, LIST_GUIDE);
	}

	void launchSearchDialog(char c){
		Intent intent = new Intent();
		intent.setAction("edu.berkeley.cs160.happytoastmobile.BorgTV.GuideSearchDialog");
		intent.putExtra("firstChar", c);
		startSubActivity(intent, SEARCH_DIALOG);
	}
	
	void launchSearch(String name){
    	Intent intent = new Intent();
		intent.setAction("edu.berkeley.cs160.happytoastmobile.BorgTV.ListGuide");
		intent.putExtra("type", "search");
		intent.putExtra("name", name);
		startSubActivity(intent, LIST_GUIDE);
	}
	
}

